import machine
from machine import Pin, PWM, I2C, ADC
import ssd1306
import time

pin = machine.Pin(5, machine.Pin.IN,machine.Pin.PULL_UP)
i2c = I2C(scl=Pin(14), sda=Pin(12))
oled = ssd1306.SSD1306_I2C(128,64,i2c)
adc = ADC(0)

#do kontroli czujnika odleglosci
class HCSR04:
    def __init__(self, trigger_pin, echo_pin, echo_timeout_us=500*2*30):
        self.echo_timeout_us = echo_timeout_us
        # Init trigger pin (out)
        self.trigger = Pin(trigger_pin, mode=Pin.OUT, pull=None)
        self.trigger.value(0)
        # Init echo pin (in)
        self.echo = Pin(echo_pin, mode=Pin.IN, pull=None)

    def _send_pulse_and_wait(self):
        self.trigger.value(0) # Stabilize the sensor
        time.sleep_us(5)
        self.trigger.value(1)
        # Send a 10us pulse.
        time.sleep_us(10)
        self.trigger.value(0)
        try:
            pulse_time = machine.time_pulse_us(self.echo, 1, self.echo_timeout_us)
            return pulse_time
        except OSError as ex:
            if ex.args[0] == 110: # 110 = ETIMEDOUT
                raise OSError('Out of range')
            raise ex

    def distance_mm(self):
        pulse_time = self._send_pulse_and_wait()
        mm = pulse_time * 100 // 582
        return mm

    def distance_cm(self):
        pulse_time = self._send_pulse_and_wait()
        cms = (pulse_time / 2) / 29.1
        return cms
    
sensor = HCSR04(trigger_pin=2, echo_pin=4, echo_timeout_us=10000)

#definicje potrzebne do przeliczania i wyswietlania wartosci w jednostkach
def wyswietl_Wartosc_mili_2(a):
    oled.fill(0)
    oled.text(a, 0, 32,1)
    oled.text('milimetr', 0, 42, 1)
    oled.show()
def wyswietl_Wartosc_mega_2(a):
    oled.fill(0)
    oled.text(a, 0, 32,1)
    oled.text('megametr', 0, 42, 1)
    oled.show()
def wyswietl_Wartosc_kilo_2(a):
    oled.fill(0)
    oled.text(a, 0, 32,1)
    oled.text('kilometr', 0, 42, 1)
    oled.show()
def wyswietl_Wartosc_mili(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('milimetr', 0, 11, 1)
    oled.show()    
def wyswietl_Wartosc_nano(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('nanometr', 0, 11, 1)
    oled.show()
def wyswietl_Wartosc_mikro(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('mikrometr', 0, 11, 1)
    oled.show()
def wyswietl_Wartosc_centy(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('centymetr', 0, 11, 1)
    oled.show()
def wyswietl_Wartosc_mega(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('megametr', 0, 11, 1)
    oled.show()
def wyswietl_Wartosc_deka(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('dekametr', 0, 11, 1)
    oled.show()
def wyswietl_Wartosc_kilo(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('kilometr', 0, 11, 1)
    oled.show()
def wyswietl_Wartosc_decy(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('decymetr', 0, 11, 1)
    oled.show()
def wyswietl_Wartosc_hekto(a):
    oled.fill(0)
    oled.text(a, 0, 0,1)
    oled.text('hektometr', 0, 11, 1)
    oled.show()
    
while True:              #glowna petla sluzaca do zapetlenia calego programu
        
    #WYBOR TRYBU
    odleglosc = 10
    check1 = True
    oled.fill(0)
    b = 0
    a = 0
    while check1 == True:
        oled.fill(0)
        if adc.read() < 500:                             #wybor 1, do treningu
            oled.fill(0)
            oled.text('Wybierz tryb', 0, 0, 1)
            oled.text('1. Trening', 0, 11, 1)
            oled.text('2. Gra', 0, 22, 1)
            oled.hline(0, 20, 20, 1)
            oled.show()
            
            if pin.value() == 0:                    #warunek rozpoczecia treningu
                oled.fill(0)
                oled.text('Wybrano', 0,0,1)
                oled.text('tryb', 0,11, 1)
                oled.text('Treningowy', 0,22,1)
                oled.show()
                a = 0.1
                check1 = False
                continue
            else:
                continue
            
        elif adc.read() >= 500:              #wybor drugi do gry
            oled.fill(0)
            oled.text('Wybierz tryb', 0, 0, 1)
            oled.text('1. Trening', 0, 11, 1)
            oled.text('2. Gra', 0, 22, 1)
            oled.hline(0, 31, 20, 1)
            oled.show()
            
            if pin.value() == 0:                  #warunek rozpoczecia gry
                oled.fill(0)
                oled.text('Wybrano', 0,0,1)
                oled.text('tryb', 0,11, 1)
                oled.text('Gry', 0,22,1)
                oled.show()
                b = 100
                check1 = False
                continue
            else:
                continue
        else:
            continue

    #TRYB TRENINGOWY          zmienna a sluzy do przechodzenia z jednego przykładu do następnego

    wybor = 0

    while a == 0.1:             #0.1 kilometra 
        value = adc.read()
        #oled.fill(0)
        oled.text(str(a), 0,0,1)                                  #wyswietlenie wartosci ktora uczen ma przemienic na odpowiednie jednostki
        oled.text('kilometr', 0, 11, 1)
        oled.show()
        if pin.value() == 0 and wybor == 4:
            oled.fill(0)
            oled.text('Dobra jednostka', 0, 0, 1)
            oled.show()
            time.sleep(2)
            a = 1                                # kolejna wartosc teraz 1 gigametr
        else:
            if value < 170:
                wyswietl_Wartosc_mili_2('1.000   ')
                wybor = 1
            elif value < 340:
                wyswietl_Wartosc_mili_2('10.000   ')
                wybor = 2
            elif value < 510:
                wyswietl_Wartosc_mili_2('100.000   ')
                wybor = 3
            elif value < 680:
                wyswietl_Wartosc_mili_2('1.000.000   ')
                wybor = 4
            elif value < 850:
                wyswietl_Wartosc_mili_2('10.000.000   ')
                wybor = 5
            else:
                wyswietl_Wartosc_mili_2('100.000.000   ')
                wybor = 6
                    
    while a == 1:
        value = adc.read()
        #oled.fill(0)
        oled.text(str(a), 0,0,1)
        oled.text('gigametr', 0, 11, 1)
        oled.show()
        if pin.value() == 0 and wybor == 1:
            oled.fill(0)
            oled.text('Dobra jednostka', 0, 0, 1)
            oled.show()
            time.sleep(2)
            a = 10                               # kolejna wartosc teraz 10 mikrometr
        else:
            if value < 170:
                wyswietl_Wartosc_mega_2('1.000')
                wybor = 1
            elif value < 340:
                wyswietl_Wartosc_mega_2('10.000')
                wybor = 2
            elif value < 510:
                wyswietl_Wartosc_mega_2('100.000')
                wybor = 3
            elif value < 680:
                wyswietl_Wartosc_mega_2('1.000.000')
                wybor = 4
            elif value < 850:
                wyswietl_Wartosc_mega_2('10.000.000')
                wybor = 5
            else:
                wyswietl_Wartosc_mega_2('100.000.000')
                wybor = 6
                
    while a == 10:
        value = adc.read()
        #oled.fill(0)
        oled.text(str(a), 0,0,1)                    #wyswietlenie wartosci ktora uczen ma przemienic na odpowiednie jednostki
        oled.text('mikrometr', 0, 11, 1)
        oled.show()
        if pin.value() == 0 and wybor == 3:
            oled.fill(0)
            oled.text('Dobra jednostka', 0, 0, 1)
            oled.show()
            time.sleep(2)
            a = 100                                # kolejna wartosc teraz 100 centymetrów
        else:
            if value < 170:
                wyswietl_Wartosc_mili_2('0.0001')
                wybor = 1
            elif value < 340:
                wyswietl_Wartosc_mili_2('0.001')
                wybor = 2
            elif value < 510:
                wyswietl_Wartosc_mili_2('0.01')
                wybor = 3
            elif value < 680:
                wyswietl_Wartosc_mili_2('0.1')
                wybor = 4
            elif value < 850:
                wyswietl_Wartosc_mili_2('1')
                wybor = 5
            else:
                wyswietl_Wartosc_mili_2('10')
                wybor = 6

    while a == 100:
        value = adc.read()
        #oled.fill(0)
        oled.text(str(a), 0,0,1)
        oled.text('centymetr', 0, 11, 1)
        oled.show()
        if pin.value() == 0 and wybor == 2:
            oled.fill(0)
            oled.text('Dobra jednostka', 0, 0, 1)
            oled.show()
            time.sleep(2)
            a = 1000000                                # kolejna wartosc teraz 1000000 nanometr
        else:
            if value < 170:
                wyswietl_Wartosc_kilo_2('0.0001')
                wybor = 1
            elif value < 340:
                wyswietl_Wartosc_kilo_2('0.001')
                wybor = 2
            elif value < 510:
                wyswietl_Wartosc_kilo_2('0.01')
                wybor = 3
            elif value < 680:
                wyswietl_Wartosc_kilo_2('0.1')
                wybor = 4
            elif value < 850:
                wyswietl_Wartosc_kilo_2('1')
                wybor = 5
            else:
                wyswietl_Wartosc_kilo_2('10')
                wybor = 6

    while a == 1000000:
        value = adc.read()
        #oled.fill(0)
        oled.text(str(a), 0,0,1)
        oled.text('nanometr', 0, 11, 1)
        oled.show()
        if pin.value() == 0 and wybor == 6:
            oled.fill(0)
            oled.text('Dobra jednostka', 0, 0, 1)
            oled.show()
            time.sleep(2)
            a = 4                                #zakończenie i przejscie dalej z programem
        else:                                                      # kod służący do przesuwania przecinka za pomocą potencjometru
            if value < 170:
                wyswietl_Wartosc_mili_2('0.00000001')
                wybor = 1
            elif value < 340:
                wyswietl_Wartosc_mili_2('0.0000001')
                wybor = 2
            elif value < 510:
                wyswietl_Wartosc_mili_2('0.000001')
                wybor = 3
            elif value < 680:
                wyswietl_Wartosc_mili_2('0.00001')
                wybor = 4
            elif value < 850:
                wyswietl_Wartosc_mili_2('0.0001')
                wybor = 5
            else:
                wyswietl_Wartosc_mili_2('0.001')
                wybor = 6
    while a == 4:
        oled.fill(0)
        oled.text('Gratulacje', 0, 0, 1)
        oled.show()
        time.sleep(2)
        oled.fill(0)
        oled.text('Czas na gre', 0, 0,1)
        oled.show()
        time.sleep(1)
        a = 7                            #w celu wylaczenia trybu treningowego
        b = 100
        odleglosc = 10
         
    #TRYB GRA                            #zmienna B służy do przechodzenia z jednego przykładu do kolejnego
    while b == 100:
        distance = sensor.distance_cm()
        if odleglosc < distance+1.5 and odleglosc > distance-1.5:   #pewien zakres dobrej odpowiedzi ze względu na dokładność pomiaru urzadzenia, można rozszerzyć, ale raczej ok
            oled.fill(0)
            oled.text('Prawidlowa', 0,0,1)
            oled.text('Odleglosc', 0,11, 1)
            oled.show()
            if pin.value()==0: 
                b = 0.001                           # poszukiwana wartosc 0.001 kilometra
                odleglosc = 100
        else:
            wyswietl_Wartosc_mili(str(b))                      #funkcja wyswietlajaca liczbe w mm
            
    while b == 0.001:
        distance = sensor.distance_cm()
        if odleglosc < distance+20 and odleglosc > distance-20:   #pewien zakres dobrej odpowiedzi ze względu na dokładność pomiaru urzadzenia, można rozszerzyć, ale raczej ok
            oled.fill(0)
            oled.text('Prawidlowa', 0,0,1)
            oled.text('Odleglosc', 0,11, 1)
            oled.show()
            if pin.value() == 0:
                b = 30000                          # poszukiwana wartosc nanometry
                odleglosc = 30
            else:
                continue
        else:
            wyswietl_Wartosc_kilo(str(b))                      #funkcja wyswietlajaca liczbe w kilometrach
    while b == 30000:
        distance = sensor.distance_cm()
        if odleglosc < distance+1.5 and odleglosc > distance-1.5:   #pewien zakres dobrej odpowiedzi ze względu na dokładność pomiaru urzadzenia, można rozszerzyć, ale raczej ok
            oled.fill(0)
            oled.text('Prawidlowa', 0,0,1)
            oled.text('Odleglosc', 0,11, 1)
            oled.show()
            if pin.value() == 0:
                b = 7                          # wyjście z gry
                odleglosc = 0
            else:
                continue
        else:
            wyswietl_Wartosc_nano(str(b))                      #funkcja wyswietlajaca liczbe w nanometrach
    while b == 7:
        oled.fill(0)
        oled.text('Dzieki za gre', 0, 0 ,1)
        oled.show()
        time.sleep(2)
        check1 = True
        b = 0
